using Sailboat.Entities;
using Sailboat.DrawingObjects;

namespace Sailboat
{
    public partial class FormSailboat : Form
    {
        private DrawingSailboat? _drawingSailboat;
        public FormSailboat()
        {
            InitializeComponent();
        }
        private void Draw()
        {
            if (_drawingSailboat == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxSailboat.Width,
            pictureBoxSailboat.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawingSailboat.DrawTransport(gr);
            pictureBoxSailboat.Image = bmp;
        }
        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawingSailboat = new DrawingSailboat(random.Next(100, 300), random.Next(1000, 3000), Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)), Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)),
            Convert.ToBoolean(random.Next(0, 2)), pictureBoxSailboat.Width, pictureBoxSailboat.Height);
            _drawingSailboat.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();
        }
        private void buttonMove_Click(object sender, EventArgs e)
        {
            if (_drawingSailboat == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _drawingSailboat.MoveTransport(DirectionType.Up);
                    break;
                case "buttonDown":
                    _drawingSailboat.MoveTransport(DirectionType.Down);
                    break;
                case "buttonLeft":
                    _drawingSailboat.MoveTransport(DirectionType.Left);
                    break;
                case "buttonRight":
                    _drawingSailboat.MoveTransport(DirectionType.Right);
                    break;
            }
            Draw();

        }

        private void pictureBoxSailboat_Click(object sender, EventArgs e)
        {

        }
    }
} 